!+
! Module: dssremove_mod
!
! Authors:  Ian Stewart - SSC/LUX
!          
! Description: A tasklet to remove the DSS from a block.
! 
! Comments: TODO:
! 
! $Id: module.f90,v 1.6 1998/05/27 13:45:39 gvacanti Exp $
!- 
module dssremove_mod

  use types

  use param
  use dal
  use errorHandling
  use dss

  use dss_aux	! for dumpDss
  use dal_aux	! for splitSetTabName

  implicit none 

  private 

  ! Command-line parameters:
  character(255) ::&
    setName
  character(20) ::&
    extensionType,&
    tabName,&
    arrayName
  integer ::&
    extensionNum

  public dssremove

contains 

  !---------------------------------------------------------------------
  subroutine dssremove
  !---------------------------------------------------------------------

    implicit none

    type(DataSetT) :: set
    type(BlockT) :: dssBlock
    type(DssT) ::&
      dssPointer

    !-------------------------------------------------------------------
    ! Start

    call readParameters

    set = dataSet(setName, MODIFY)

    select case(extensionType)
    case('bintabname')
      dssBlock = block(set, tabName)!, READ)

    case('arrayname')
      dssBlock = block(set, arrayName)!, READ)

    case('number')
      dssBlock = block(set, extensionNum)!, READ)

    case default
call error('',"")
    end select

if (.not. hasDss(dssBlock)) call error('noDss',"") ! in ssclib/dss_aux

    dssPointer = dataSubspace(dssBlock)
    call dssDelete(dssBlock) ! in dsslib

    call release(set)
    call dssRelease(dssPointer)

  end subroutine dssremove

  !---------------------------------------------------------------------
  subroutine readParameters
  !---------------------------------------------------------------------

    implicit none

    !-------------------------------------------------------------------
    ! Start

    setName = stringParameter('set')
    extensionType = stringParameter('exttype')
    select case(extensionType)
    case('bintabname')
      tabName = stringParameter('table')

    case('arrayname')
      arrayName = stringParameter('array')

    case('number')
      extensionNum = intParameter('extn')

    case default
call error('',"")
    end select

  end subroutine readParameters

  !---------------------------------------------------------------------
  subroutine template
  !---------------------------------------------------------------------

    implicit none

    !-------------------------------------------------------------------
    ! Start

  end subroutine template

end module dssremove_mod
